<script lang="ts">
  import { Badge, Button, ButtonGroup, Col, Row, Tooltip } from '@sveltestrap/sveltestrap';
  import type { ChallengeFile } from '@models/Challenges';
  import { type PreSignedUrlResponse, storageApiRequest } from "@utils/FileStorageApi";
  import prettyBytes from 'pretty-bytes';
  import { onMount } from 'svelte';
  import Fa from 'svelte-fa';
  import { faCopy, faDownload } from '@fortawesome/free-solid-svg-icons';

  export let file: ChallengeFile;
  let presignedUrl: string;
  let copyBtn: HTMLElement;
  let downloadBtn: HTMLElement;
  let copyBtnTooltip: string = 'Copy File URL';
  let copyTextArea;

  onMount(async () => {
    const response = await storageApiRequest<PreSignedUrlResponse>('GET', `/v1/files/${file.file_id || file.file.id}/presignedurl`)
    presignedUrl = response.data.url;
  });

  function copyText(value: string) {
    // Select the text field
    copyTextArea.select();
    copyTextArea.setSelectionRange(0, 99999); // For mobile devices
    copyTextArea.value = value;

    // Copy the text inside the text field
    navigator.clipboard.writeText(copyTextArea.value);
    copyBtnTooltip = 'URL Copied!';
    setTimeout(() => (copyBtnTooltip = 'Copy File Url'), 3000);
  }
</script>

<textarea class="d-none" bind:this={copyTextArea} />

<Row class="py-1 px-0">
  <Col class="col-9">
    <ButtonGroup size="sm" class="pe-2">
      <Button bind:inner={copyBtn} on:click={() => copyText(presignedUrl)}>
        <Fa icon={faCopy} tooltip="Copy file Link" />
      </Button>
      <Tooltip target={copyBtn}>{copyBtnTooltip}</Tooltip>

      <Button bind:inner={downloadBtn} target="_blank" href={presignedUrl} download={file.file.name}>
        <Fa icon={faDownload} tooltip="Download File" />
      </Button>
      <Tooltip target={downloadBtn}>Download File</Tooltip>
    </ButtonGroup>
    <span class="me-auto">{file.file.name}</span>
  </Col>
  <Col class="col-3">
    <Badge color="primary">Size: {prettyBytes(file.file.size)}</Badge>
  </Col>
</Row>
